Inc_Value:
	lda	<cursor_opt
	cmp	#$06
	beq	.inc_vdc_d	;Are we changing #D (A WORD)?
	cmp	#$07
	beq	.inc_vdc_e	;Are we changing #E (A Byte)?
	bpl	.inc_sprites
;-------------------------- otherwise, it's a regular reg (0-5)
	tax
	inc	<VDC_A_LO,X	;Increase proper register
	lsr	a		;Cut in half
	pha
	add	#$0A
	sta	$0000		;Save to VRAM register!
	stz	$0001
	pla
	asl	a
	tax
	lda	<VDC_A_LO,X
	sta	$0002
	lda	<VDC_A_LO+1,X
	sta	$0003		;Write to VDC!
	bra	.increg_done
.inc_vdc_d:
	incw	<VDC_D		;Increase word
	vreg	#$0D
	stw	<VDC_D,video_data
	bra	.increg_done
.inc_vdc_e:
	inc	<VDC_E_LO		;Increase byte
	vreg	#$0E
	stw	<VDC_E_LO,video_data
	bra	.increg_done
;-------------------------------
.inc_sprites:
	sub	#$08			;Get rid of offset
	asl	a			;Word offset
	tax
	lda	<Sprite1X,X
	add	#$01
	sta	<Sprite1X,X
	lda	<Sprite1X+1,X
	adc	#$00
	sta	<Sprite1X+1,X
	jsr	Move_Sprites
.increg_done:
	jsr	Draw_VDC_Regs
	rts

Dec_Value:
	lda	<cursor_opt
	cmp	#$06
	beq	.dec_vdc_d	;Are we changing #D (A WORD)?
	cmp	#$07
	beq	.dec_vdc_e	;Are we changing #E (A Byte)?
	bpl	.dec_sprites
;-------------------------- otherwise, it's a regular reg (0-5)
	tax
	dec	<VDC_A_LO,X	;Increase proper register
	lsr	a		;Cut in half
	pha
	add	#$0A
	sta	$0000		;Save to VRAM register!
	stz	$0001
	pla
	asl	a
	tax
	lda	<VDC_A_LO,X
	sta	$0002
	lda	<VDC_A_LO+1,X
	sta	$0003		;Write to VDC!
	bra	.decreg_done
.dec_vdc_d:
	decw	<VDC_D		;Decrease word
	vreg	#$0D
	stw	<VDC_D,video_data
	bra	.decreg_done
.dec_vdc_e:
	dec	<VDC_E_LO		;Decrease byte
	vreg	#$0E
	stw	<VDC_E_LO,video_data
	bra	.decreg_done
;-------------------------------
.dec_sprites:
	sub	#$08			;Get rid of offset
	asl	a			;Word offset
	tax
	lda	<Sprite1X,X
	sub	#$01
	sta	<Sprite1X,X
	lda	<Sprite1X+1,X
	sbc	#$00
	sta	<Sprite1X+1,X
	jsr	Move_Sprites
.decreg_done:
	jsr	Draw_VDC_Regs
	rts


Draw_VDC_Text:
	lda	#$05
	sta	<line_number
	lda	#04
	sta	<row_number
	jsr	goto_line_no

	stw	#VDCA1_Txt,<_si
	ldx	#$01
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCA2_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCB1_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCB2_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCC1_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCC2_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCD_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#VDCE_Txt,<_si

	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Sp1_Txt,<_si
	ldx	#$02
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Sp2_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Sp3_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Sp4_Txt,<_si
	jsr	Print_Text

	inc	<line_number
	inc	<line_number
	dec	<row_number
	dec	<row_number
	jsr	goto_line_no
	stw	#Bot1_Txt,<_si
	clx
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Bot2_Txt,<_si
	jsr	Print_Text
	inc	<line_number
	jsr	goto_line_no
	stw	#Bot3_Txt,<_si
	jsr	Print_Text

;	ldx	#$02
;	inc	<line_number
;	jsr	goto_line_no
;	stw	#Bot4_Txt,<_si
;	jsr	Print_Text
;	inc	<line_number
;	lda	#$06
;	sta	<row_number
;	jsr	goto_line_no
;	stw	#Bot5_Txt,<_si
;	jsr	Print_Text
	rts

Draw_VDC_Regs:
	lda	#$05
	sta	<line_number
	lda	#$0A
	sta	<row_number
	jsr	goto_line_no

	lda	<VDC_A_LO
	clx
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_A_HI
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_B_LO
;-------------
	sta	<bcd_inp0	;For BCD
	stz	<bcd_inp1
	inc	<bcd_inp0	;INC first. (HDW-1)
	asl	<bcd_inp0
	rol	<bcd_inp1
	asl	<bcd_inp0
	rol	<bcd_inp1
	asl	<bcd_inp0
	rol	<bcd_inp1	;Multiply by 8.
	jsr	conv_bcd	;Convert to BCD
	jsr	Print_Byte
	lda	<row_number
	pha
	lda	#$1A
	sta	<row_number
	jsr	goto_line_no
	pla
	sta	<row_number
	lda	<bcd_out1
	jsr	Print_Byte
	lda	<bcd_out2
	jsr	Print_Byte
;----------------
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_B_HI
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_C_LO
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_C_HI
	jsr	Print_Byte
	inc	<line_number
	dec	<row_number
	dec	<row_number
	jsr	goto_line_no
;-------------
	lda	<VDC_D+1
	sta	<bcd_inp1
	jsr	Print_Byte
	lda	<VDC_D
	sta	<bcd_inp0	;For BCD
	jsr	Print_Byte
;-------------
	incw	<bcd_inp0	;INC first. (HDW-1)
	jsr	conv_bcd	;Convert to BCD
	lda	<row_number
	pha
	lda	#$1A
	sta	<row_number
	jsr	goto_line_no
	pla
	sta	<row_number
	lda	<bcd_out1
	jsr	Print_Byte
	lda	<bcd_out2
	jsr	Print_Byte
;----------------
	inc	<row_number
	inc	<row_number
	inc	<line_number
	jsr	goto_line_no
	lda	<VDC_E_LO
	jsr	Print_Byte
	rts

Draw_SprPos:
	lda	#$0D
	sta	<line_number
	lda	#$0F
	sta	<row_number
	jsr	goto_line_no

	lda	<Sprite1X+1	;Print Our Movable Sprites
	clx
	jsr	Print_Byte
	lda	<Sprite1X
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<Sprite2X+1	;Print Our Movable Sprites
	jsr	Print_Byte
	lda	<Sprite2X
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<Sprite3Y+1	;Print Our Movable Sprites
	jsr	Print_Byte
	lda	<Sprite3Y
	jsr	Print_Byte
	inc	<line_number
	jsr	goto_line_no
	lda	<Sprite4Y+1	;Print Our Movable Sprites
	jsr	Print_Byte
	lda	<Sprite4Y
	jsr	Print_Byte

	stw	<Sprite2X,<bcd_inp0
	subw	<Sprite1X,<bcd_inp0
	addw	#$10,<bcd_inp0		;Get H-Size
	jsr	conv_bcd
	lda	#$0E
	sta	<line_number
	lda	#$19
	sta	<row_number
	jsr	goto_line_no
	lda	<bcd_out1
	clx
	jsr	Print_Byte
	lda	<bcd_out2
	jsr	Print_Byte

	stw	<Sprite4Y,<bcd_inp0
	subw	<Sprite3Y,<bcd_inp0
	addw	#$10,<bcd_inp0		;Get V-Size
	jsr	conv_bcd
	inc	<line_number
	inc	<line_number
	jsr	goto_line_no
	lda	<bcd_out1
	clx
	jsr	Print_Byte
	lda	<bcd_out2
	jsr	Print_Byte

	rts

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

TestJoypad:
;JOY_I		= $01
;JOY_II		= $02
;JOY_SEL	= $04
;JOY_RUN	= $08
;JOY_UP		= $10
;JOY_RIGHT	= $20
;JOY_DOWN	= $40
;JOY_LEFT	= $80
	tst	#JOY_DOWN,joytrg
	beq	.NoPushDown
	inc	<cursor_opt
	lda	<cursor_opt
	cmp	#$0C
	bne	.no_opt_high
	stz	<cursor_opt
.no_opt_high:
	jsr	Move_Cursor
	jmp	.TstJoyEnd
;-----------------------------------------
.NoPushDown:
	tst	#JOY_UP,joytrg
	beq	.NoPushUp
	dec	<cursor_opt
	lda	<cursor_opt
	cmp	#$ff
	bne	.no_opt_low
	lda	#$0B
	sta	<cursor_opt
.no_opt_low:
	jsr	Move_Cursor
	jmp	.TstJoyEnd
;-----------------------------------------
.NoPushUp:
	tst	#JOY_RIGHT,joytrg	;This is RIGHT
	beq	.PushRight
	jmp	.NoPushRight
.PushRight:
;-----------------------------------------
.NoPushRight
	tst	#JOY_LEFT,joytrg	;This is LEFT
	beq	.PushLeft
	jmp	.NoPushLeft
.PushLeft:
;-----------------------------------------
.NoPushLeft
	tst	#JOY_I,joytrg		;This is I
	beq	.NoPushbutI
	jsr	Inc_Value
	jmp	.TstJoyEnd
;-----------------------------------------
.NoPushbutI
	tst	#JOY_II,joytrg		;This is II
	beq	.NoPushbutII
	jsr	Dec_Value
	jmp	.TstJoyEnd
;-----------------------------------------
.NoPushbutII:
	tst	#JOY_RUN,joytrg		;This is RUN
	beq	.NoPushRUN
	lda	<evnodd			;Get even/odd line mode
	eor	#%00000100
	sta	<evnodd
	lda	VCE_copy
	and	#%11111011
	ora	<evnodd
	sta	VCE_copy
	sta	$0400			;Save it to VCE.
	jmp	.TstJoyEnd
;-----------------------------------------
.NoPushRUN:
	tst	#JOY_SEL,joytrg		;This is SELECT
	beq	.NoPushSEL
	inc	<resmode
	lda	<resmode
	cmp	#$03
	bne	.change_res0
	stz	<resmode
.change_res0:
	lda	<resmode
	bne	.not_low_res	;Not 256
	jsr	xres_256
	bra	.TstJoyEnd
.not_low_res:
	cmp	#$01
	bne	.not_med_res	;Not 320
	jsr	xres_320
	bra	.TstJoyEnd
.not_med_res:
	jsr	xres_512
	bra	.TstJoyEnd
;-----------------------------------------
.NoPushSEL:

.TstJoyEnd:
	rts
;=======================================================================


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

Check_Queues:
	lda	<VB_task1+1	;Check if loaded?
	beq	.no_do_task1
	jsr	Queue_Helper1
	stwz	<VB_task1	;Unload task.
.no_do_task1:
	lda	<VB_task2+1	;Check if loaded?
	beq	.no_do_task2
	jsr	Queue_Helper2
	stwz	<VB_task2	;Unload task.
.no_do_task2:
	lda	<VB_task3+1	;Check if loaded?
	beq	.no_do_task3
	jsr	Queue_Helper3
	stwz	<VB_task3	;Unload task.
.no_do_task3:
	rts

Queue_Helper1:
	jmp	[VB_task1]
Queue_Helper2:
	jmp	[VB_task2]
Queue_Helper3:
	jmp	[VB_task3]

Print_Text:	;<_si: Source, <_di:VRAM add, X:palette#
	pha
	phx
	phy
	txa
	asl	a
	asl	a
	asl	a
	asl	a		;Palette # stored in X
	ora	#$01		;VRAM $1000
	tax
	cly
.PT_loop:
	lda	[_si],Y
	beq	.Print_Text_Finished
	sta	video_data
	stx	video_data+1
	incw	<_si
	bra	.PT_loop

.Print_Text_Finished:
	ply
	plx
	pla
	rts
;***************************************************



;*******************************************************************************
goto_line_no:	; print on the background

	lda   <line_number	; line #X of ~30
	sta   <a_cnt

	cla			; line number in _di
	sta   <_di+1
	lda   <a_cnt
	sta   <_di

	aslw  <_di		; multiply by $40 chars/line, to find address
	aslw  <_di		; of start-of-line (use a 6-bit left-shift)
	aslw  <_di		;One extra shift (FOR 128-tile-wide screen!)
	aslw  <_di		
	aslw  <_di
	aslw  <_di
	aslw  <_di
	addw  <row_number,<_di		;Add the row...

	jsr   set_write 	; set VRAM write address
	jsr	set_read	;Set VRAM address.
	rts

Print_Byte:	;Prints a byte to the screen.
	phx
	pha			; preserve
	lsr   a 		; use top nybble
	lsr   a
	lsr   a
	lsr   a
	jsr	write_ascii
	sta   video_data	; store char # (0-F) (LSB of VRAM word)
	txa
	asl	a
	asl	a
	asl	a
	asl	a		;Palette # stored in X
	ora	#$01		;VRAM $1000
	sta   video_data+1
	tax
.nextprintbyte
	pla			; restore byte
	and   #$0F		; use bottom nybble
	jsr	write_ascii
	sta   video_data	; store char # (0-F) (LSB of VRAM word)
	stx   video_data+1
	plx
	rts

write_ascii:
	cmp	#$0A
	blo	.not_hex_font
	add	#$37		;A..F
	bra	.hex_end
.not_hex_font
	add	#$30		;0..9
.hex_end:
	rts


clear_VRAM:		;Clears xxxx words of VRAM.
	setvwaddr  $0		; set the VRAM address to $0000
	stw	#$1000,<_si
.clear_vram0:
	st1	#$00
	st2	#$00
	decw	<_si
	bcs	.clear_vram0
	rts

mapsize_64x64:
	vreg #9
	lda	#%01010000	;Set virtual height to 64
	sta	video_data	;And width to 64!
	stz	video_data+1
	rts

mapsize_64x32:
	vreg #9
	lda	#%00010000	;Set virtual height to 32
	sta	video_data	;And width to 64!
	stz	video_data+1
	rts

mapsize_128x32:
	vreg #9
	lda	#%00100000	;Set virtual height to 32
	sta	video_data	;And width to 128!
	stz	video_data+1
	rts

yres_224:
	st0 #$0C
	stw #$1702,<VDC_C_LO
	stw #$1702,video_data
	st0 #$0D
	stw #$00DF,<VDC_D
	stw #$00DF,video_data
	st0 #$0E
	stw #$0003,<VDC_E_LO
	stw #$0003,video_data
	rts

yres_240:
	st0 #$0C
	stw #$0D02,<VDC_C_LO
	stw #$0D02,video_data
	st0 #$0D
	stw #$00EF,<VDC_D
	stw #$00EF,video_data	;$EF=239
	st0 #$0E
	stw #$0003,<VDC_E_LO
	stw #$0003,video_data
	rts

xres_256:
	vreg	#$0A
	stw	#$0202,<VDC_A_LO
	stw	#$0202,video_data
	vreg	#$0B
	stw	#$041F,<VDC_B_LO
	stw	#$041F,video_data
	lda	#%00000000
	ora	<evnodd
	sta	$0400
	sta	VCE_copy
	jsr	Draw_VDC_Regs
	jsr	Reposition_Sprites
	rts

xres_320:
	vreg	#$0A
	stw	#$0303,<VDC_A_LO
	stw	#$0303,video_data
	vreg	#$0B
	stw	#$062B,<VDC_B_LO
	stw	#$062B,video_data
	lda	#%00000001
	ora	<evnodd
	sta	$0400
	sta	VCE_copy
	jsr	Draw_VDC_Regs
	jsr	Reposition_Sprites
	rts

xres_512:
	vreg	#$0A
	stw	#$0B02,<VDC_A_LO
	stw	#$0B02,video_data
	vreg	#$0B
	stw	#$043F,<VDC_B_LO
	stw	#$043F,video_data
	lda	#%00000010
	ora	<evnodd
	sta	$0400
	sta	VCE_copy
	jsr	Draw_VDC_Regs
	jsr	Reposition_Sprites
	rts

SPRXINIT	equ	$0038
SPRYINIT	equ	$00E8
DOTSPR		equ	$020A
DOTATT		equ	$0081

Setup_Sprites:
	map	SprGfx
	load_sprites $4000,SprGfx,#1
	init_satb satb
	stw	#satb,<file_size

	stw     #SPRYINIT,<sy
	ldy	#4
.sprgrid_lp0:
	stw	#SPRXINIT,<sx
	ldx	#16
.sprgrid_lp1:
	lda	<sy
	sta	[file_size]
	incw	<file_size
 	lda	<sy+1
	sta	[file_size]
	incw	<file_size
	lda	<sx
	sta	[file_size]
	incw	<file_size
	lda	<sx+1
	sta	[file_size]
	incw	<file_size
	lda     #LOW(DOTSPR)
	sta	[file_size]
	incw	<file_size
	lda     #HIGH(DOTSPR)
	sta	[file_size]
	incw	<file_size
	lda     #LOW(DOTATT)
	sta	[file_size]
	incw	<file_size
	lda     #HIGH(DOTATT)
	sta	[file_size]
	incw	<file_size
	addw	#4,<sx
	dex
	bne     .sprgrid_lp1
	addw	#$10,<sy
	dey
	bne	.sprgrid_lp0
;============================

	stw   #$36,<sx	; that will center it on the screen
	stw   #$64,<sy

	spr_set #0,satb		;Setup the pointer.
	spr_x sx
	spr_y sy
	spr_pattern #$4000
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_16x16|NO_FLIP
	spr_pri   #1
	spr_pal   #1

	stw   #$40,Sprite3Y
	spr_set #3,satb		;Setup the 1234 Sprites.
	spr_y Sprite3Y
	spr_pattern #$40C0
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_16x16|NO_FLIP
	spr_pri   #1
	spr_pal   #1

	stw   #$11C,Sprite4Y
	spr_set #4,satb		;Setup the 1234 Sprites.
	spr_y Sprite4Y
	spr_pattern #$4100
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_16x16|NO_FLIP
	spr_pri   #1
	spr_pal   #1


	stw   #$B0,Sprite1Y
	spr_set #1,satb		;Setup the 1234 Sprites.
	spr_y Sprite1Y
	spr_pattern #$4040
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_16x16|NO_FLIP
	spr_pri   #1
	spr_pal   #1

	stw   #$B0,Sprite2Y
	spr_set #2,satb		;Setup the 1234 Sprites.
	spr_y Sprite2Y
	spr_pattern #$4080
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_16x16|NO_FLIP
	spr_pri   #1
	spr_pal   #1

	jsr	Reposition_Sprites
;	update_satb satb	; upload the BAT in VRAM

	rts

;========================================
Reposition_Sprites:
	lda	<resmode
	beq	.repos_256
	cmp	#$01
	beq	.repos_320
;-----------------------------Now it's 512!
	stw   #$210,Sprite2X
	stw   #$118,Sprite3X	; that will center it on the screen
	stw   #$118,Sprite4X
	bra	.repos_rest
.repos_256:
	stw   #$110,Sprite2X
	stw   #$98,Sprite3X	; that will center it on the screen
	stw   #$98,Sprite4X
	bra	.repos_rest
.repos_320:
	stw   #$170,Sprite2X
	stw   #$C8,Sprite3X	; that will center it on the screen
	stw   #$C8,Sprite4X
.repos_rest:
	stw   #$20,Sprite1X	; that will center it on the screen
	jsr	Move_Sprites
	rts
;========================================

Move_Sprites:
	spr_set #1,satb		;Setup the 1234 Sprites.
	spr_x Sprite1X
	spr_y Sprite1Y
	spr_set #2,satb		;Setup the 1234 Sprites.
	spr_x Sprite2X
	spr_y Sprite2Y
	spr_set #3,satb		;Setup the 1234 Sprites.
	spr_x Sprite3X
	spr_y Sprite3Y
	spr_set #4,satb		;Setup the 1234 Sprites.
	spr_x Sprite4X
	spr_y Sprite4Y
	
	jsr	Draw_SprPos
	update_satb satb
	rts

Move_Cursor:

	lda	<cursor_opt	;Scroll the cursor.
	asl	a
	asl	a
	asl	a
	sta	<sy
	stz	<sy+1
	addw	#$64,<sy	
	spr_set #0,satb		;Setup the pointer.
	spr_y sy
	update_satb satb	; upload the BAT in VRAM
	rts

Cycle_Colours:
	; Cycle the Sprite palette
	lda	<nmi_count
	lsr	a
	lsr	a
;	lsr	a
	and	#$1E		;Reduce to 0..30
	tax
	stw	#$0111,$0402

	lda	CursPal,X
	sta	$0404
	lda	CursPal+1,X
	sta	$0405		;Save palette data!
	rts